unit Mabprspl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TMabPrinterPosition = class
    Line: Integer;
    Page: Integer;

    constructor Create;
  end;

  TMabPrintSpool = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FPosition: TMabPrinterPosition;
    FFilename: TFilename;
    FPrinterName: string;
    FDescription: string;
    FPort: string;
  public
    { Public declarations }
    OutputFile: TextFile;

    constructor Create(AOwner: TComponent); override;

    procedure Open;
    procedure Close;

    function Execute: THandle;
  published
    { Published declarations }
    property Position: TMabPrinterPosition read FPosition;
    property Filename: TFilename read FFilename write FFilename;
    property PrinterName: string read FPrinterName write FPrinterName;
    property Description: string read FDescription write FDescription;
    property Port: string read FPort write FPort;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Mab', [TMabPrintSpool]);
end;

constructor TMabPrinterPosition.Create;
begin
   Line := 0;
   Page := 0;
end;

constructor TMabPrintSpool.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);

   FPosition := TMabPrinterPosition.Create;
   FFileName := '';
   FPrinterName := '';
   FDescription := '';
   FPort := 'LPT1';
end;

procedure TMabPrintSpool.Open;
var
   PFileName: array[0..144] of Char;
begin
   if FFileName = '' then
   begin
      GetTempFileName(#0, #0, 0, PFileName);
      FFileName := StrPas(PFileName);
   end;

   AssignFile(OutputFile, FFileName);
   ReWrite(OutputFile);
end;

procedure TMabPrintSpool.Close;
begin
   CloseFile(OutputFile);
end;

function TMabPrintSpool.Execute: THandle;
begin
   Result := SpoolFile(@FPrinterName[1], @FPort[1], @FDescription[1], @FFilename[1]);
end;

end.
